/* cat > headers/option.h << "EOF" */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* option.h: header for option.c file			*/
/*	     -set laser printer name			*/
/*	     -set Imagetool defaults for image		*/
/*	      directory, palette, help directory	*/
/*	     -set reversed image display (change	*/
/*	      origin)					*/
/*	     -set dark background			*/
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* SCCS information: %W%	%G% - NCSA */

#define option_h	1

#include "all.h"
#include "newext.h"

	static void set_reversed();
	static void set_darkbg();

/* EOF */
/* cat > src+obj/option/create_def_box.c << "EOF" */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* create_def_box: create defaults frame		*/
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* SCCS information: %W%	%G% - NCSA */

/* #include "option.h" */

create_def_box ()
{
	int             h, w;

	def_box = window_create (0, FRAME,
				 FRAME_SHOW_LABEL, FALSE,
				 WIN_SHOW, FALSE,
				 0);
	def_panel = window_create (def_box, PANEL,
				   PANEL_FONT, font_panel,
				   PANEL_LABEL_BOLD, TRUE,
				   0);
	panel_create_item (def_panel, PANEL_MESSAGE,
			   PANEL_LABEL_STRING, "Please enter Imagetool default paths:",
			   0);
	image_item = panel_create_item (def_panel, PANEL_TEXT,
					PANEL_VALUE_DISPLAY_LENGTH, 64,
					PANEL_VALUE_STORED_LENGTH, MAXNAMELEN - 1,
					PANEL_LABEL_STRING, "     Default image directory: ",
					PANEL_MENU_CHOICE_STRINGS,
						"^N - Get directory name",
						0,
					PANEL_MENU_CHOICE_FONTS,
						font_menu,
						0,
					PANEL_MENU_CHOICE_VALUES,
						CTRL_N,
						0,
					PANEL_SHOW_MENU, TRUE,
					PANEL_NOTIFY_LEVEL, PANEL_ALL,
					PANEL_NOTIFY_PROC, defaults_proc,
					PANEL_CLIENT_DATA, 1,
					0);
	pal_item = panel_create_item (def_panel, PANEL_TEXT,
				      PANEL_VALUE_DISPLAY_LENGTH, 64,
				      PANEL_VALUE_STORED_LENGTH, MAXNAMELEN - 1,
				      PANEL_LABEL_STRING, "     Default palette: ",
				      PANEL_MENU_CHOICE_STRINGS,
				      		"^N - Get file name",
				      		0,
				      PANEL_MENU_CHOICE_FONTS,
				      		font_menu,
				      		0,
				      PANEL_MENU_CHOICE_VALUES,
				      		CTRL_N,
				      		0,
				      PANEL_SHOW_MENU, TRUE,
				      PANEL_NOTIFY_LEVEL, PANEL_ALL,
				      PANEL_NOTIFY_PROC, defaults_proc,
				      PANEL_CLIENT_DATA, 2,
				      0);
	help_item = panel_create_item (def_panel, PANEL_TEXT,
				       PANEL_VALUE_DISPLAY_LENGTH, 64,
				       PANEL_VALUE_STORED_LENGTH, MAXNAMELEN - 1,
				       PANEL_LABEL_STRING, "     Default help file directory: ",
				       PANEL_MENU_CHOICE_STRINGS,
				       		"^N - Get directory name",
				       		0,
				       PANEL_MENU_CHOICE_FONTS,
				       		font_menu,
				       		0,
				       PANEL_MENU_CHOICE_VALUES,
				       		CTRL_N,
				       		0,
				       PANEL_SHOW_MENU, TRUE,
				       PANEL_NOTIFY_LEVEL, PANEL_ALL,
				       PANEL_NOTIFY_PROC, defaults_proc,
				       PANEL_CLIENT_DATA, 3,
				       0);
	save_toggle = panel_create_item (def_panel, PANEL_CYCLE,
					 PANEL_LABEL_STRING, "Save:",
					 PANEL_CHOICE_STRINGS,
					 	"This session only",
					 	"This session and defaults file",
					 	0,
					 0);
	panel_create_item (def_panel, PANEL_BUTTON,
			   PANEL_LABEL_IMAGE, panel_button_image (def_panel, "Ok", 3, font_panel_button),
			   PANEL_CLIENT_DATA, 1,
			   PANEL_NOTIFY_PROC, def_ok_cancel,
			   0);
	panel_create_item (def_panel, PANEL_BUTTON,
			   PANEL_LABEL_IMAGE, panel_button_image (def_panel, "Cancel", 6, font_panel_button),
			   PANEL_CLIENT_DATA, 0,
			   PANEL_NOTIFY_PROC, def_ok_cancel,
			   0);
	window_fit (def_panel);
	window_fit (def_box);

	w = (int) window_get (def_box, WIN_WIDTH);
	h = (int) window_get (def_box, WIN_HEIGHT);
	window_set (def_box, WIN_X, 1150 / 2 - w / 2, WIN_Y, 900 / 2 - h / 2, 0);

		/* set color map same with imagetool */
	(void) color_def_win ();

}
/* EOF */
/* cat > src+obj/option/create_opt_menu.c << "EOF" */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* create_opt_menu: create option menu			*/
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* SCCS information: %W%	%G% - NCSA */

/* #include "option.h" */

create_opt_menu ()
{
	option_menu = menu_create (
				   MENU_FONT, font_menu,
				   MENU_GEN_PROC, option_mark_menu,
				   MENU_ACTION_ITEM, "Set default paths", set_defaults,
				   MENU_ACTION_ITEM, "Set laser printer default", set_printer,
				   MENU_ACTION_ITEM, "Set reversed image on", set_reversed,
				   MENU_ACTION_ITEM, "Set dark background on", set_darkbg,
				   0);
}
/* EOF */
/* cat > src+obj/option/create_printer_menu.c << "EOF" */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* create_printer_menu: create printer menu with	*/
/*			with entries from		*/
/*			/etc/printcap			*/
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* SCCS information: %W%	%G% - NCSA */

/* #include "option.h" */

create_printer_menu ()
{
		/* initialize printer menu */
	printer_menu = menu_create (MENU_FONT, font_menu,
				    MENU_NOTIFY_PROC, printer_proc,
				    0);
	(void) getname_printer (printer_menu);
}
/* EOF */
/* cat > src+obj/option/def_ok_cancel.c << "EOF" */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* def_ok_cancel: cancel notify proc for defaults	*/
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* SCCS information: %W%	%G% - NCSA */

/* #include "option.h" */

def_ok_cancel (item, event)
	Panel_item      item;
	Event          *event;
{
	int             which_item;
	int             value, err;
	char            dir[MAXNAMELEN], pal[MAXNAMELEN], help[MAXNAMELEN];
	enum pal_type   ptype;

	if ((which_item = (int) panel_get (item, PANEL_CLIENT_DATA)))
	{
		strcpy (dir, (char *) panel_get_value (image_item));
		strcpy (pal, (char *) panel_get_value (pal_item));
		strcpy (help, (char *) panel_get_value (help_item));

			/* check values  - report first error and wait for the
					   user to respond again */

			/* image directory - null string OK */

		if (word_count (dir) != 0)	/* non-null entry */
		{
			sprintf (wkstr, "csh -fc \"test -d '%s'\"", dir);
/* printf ("wkstr = %s\n", wkstr); */
			if (check_system (wkstr))	/* 0 exit status means true */
			{
				msg_write ("Error: Image directory is bad or does not exist. Fix or cancel.");
				return;
			}
			else
			{		/* fully resolve pathname */
				if ((err = get_abspathname (dir, MAXNAMELEN, 0)))
				{		/* error should not occur */
					sprintf (wkstr, "Internal error (%d): While resolving default image directory. Cancel and report bug!", err);
					msg_write (wkstr);
					return;
				}
/* printf ("dir = %s\n", dir); */
			}
		}
		else		/* be sure string is null */
			*dir = '\0';

			/* palette - null string OK */
		if (word_count (pal) != 0)
		{		/* non-null entry */
			sprintf (wkstr, "csh -fc \"test -f '%s'\"", pal);
			if (check_system (wkstr))
			{		/* 0 exit status means true */
				msg_write ("Error: Palette filename is bad or file does not exist. Fix or cancel.");
				return;
			}
			else
			{		/* fully resolve pathname */
				if ((err = get_abspathname (pal, MAXNAMELEN, 1)))
				{		/* error should not occur */
					sprintf (wkstr, "Internal error (%d): While resolving default palette filename. Cancel and report bug!", err);
					msg_write (wkstr);
					return;
				}
					/* compare with current palette */
				if (strcmp (pal, curr_pal.fn) && curr_pal.type == PAL_UNKNOWN)
				{
					if ((err = check_palette (pal, &ptype)))
					{
						switch (err)
						{
							case 2:
								msg_write ("Error: Raw palette size != 768. Choose another file or cancel.");
								return;
							case 3:
								msg_write ("Error: HDF file has no palettes. Choose another file or cancel.");
								return;
							default:
								sprintf (wkstr, "HDF file error: (DFerror = %d) while checking palette. Choose another file or cancel.");
								msg_write (wkstr);
								return;
						}
					}
					strcpy (default_pal.fn, pal);
					default_pal.type = ptype;
					switch (ptype)
					{
						case PAL_RAW:
							default_pal.num = 0;
							break;
						case PAL_HDF:
							default_pal.num = 1;
							break;
					}
				}
				strcpy (default_pal.fn, curr_pal.fn);
				default_pal.type = curr_pal.type;
				default_pal.num = curr_pal.num;
/* printf ("pal = %s\n", pal); */
			}
		}
		else
		{		/* be sure string is null */
			default_pal.fn[0] = '\0';
			default_pal.type = PAL_UNKNOWN;
			default_pal.num = 0;
		}

			/* help directory - null string NOT OK */
		if (word_count (help) != 0)	/* non-null entry */
		{
			sprintf (wkstr, "csh -fc \"test -d '%s'\"", help);
			if (check_system (wkstr))
			{		/* 0 exit status means true */
				msg_write ("Error: Help directory is bad or does not exist. Fix or cancel.");
				return;
			}
			else
			{		/* fully resolve pathname */
				if ((err = get_abspathname (help, MAXNAMELEN, 0)))	/* error should not occur */
				{
					sprintf (wkstr, "Internal error (%d): While resolving help directory. Cancel and report bug!", err);
					msg_write (wkstr);
					return;
				}
/* printf ("help = %s\n", help); */
			}
		}
		else
		{
			msg_write ("Error: Help directory cannot be null. Fix or cancel.");
			return;
		}

			/* save values */
		strcpy (default_cdir, dir);
			/* pal saved above */
		strcpy (help_dir, help);

		value = (int) panel_get_value (save_toggle);
		switch (value)
		{
			case 0:/* session only */
				msg_write ("Note: Defaults saved (session only).");
				break;
			case 1:/* session and ~/.defaults file */

				if (default_pal.type == PAL_RIS8)
					msg_write ("Warning: Default palette is associated with a 8-Bit Raster Image.");
				put_defaults (dir, pal, help);
				msg_write ("Note: Defaults saved (session and defaults file).");
				break;
		}
		window_set (def_box, WIN_SHOW, FALSE, 0);
	}
	else
		window_set (def_box, WIN_SHOW, FALSE, 0);

	return;
}
/* EOF */
/* cat > src+obj/option/defaults_proc.c << "EOF" */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* defaults_proc: notify proc for defaults panel text	*/
/*		  items					*/
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* SCCS information: %W%	%G% - NCSA */

/* #include "option.h" */

Panel_setting
defaults_proc (item, event)
	Panel_item      item;
	Event          *event;
{
	int             which_item;

	switch (event_id (event))
	{
		case CTRL_N:
			which_item = (int) panel_get (item, PANEL_CLIENT_DATA);
			switch (which_item)
			{
				case 1:
					(void) display_pathnamesw ("Get default image directory", update_default_image);
					break;
				case 2:
					(void) display_pathnamesw ("Get default palette filename", update_default_pal);
					break;
				case 3:
					(void) display_pathnamesw ("Get default help directory", update_default_help);
					break;
			}
			return PANEL_NONE;
		default:
			return panel_text_notify (item, event);
	}
}
/* EOF */
/* cat > src+obj/option/get_defaults.c << "EOF" */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* get_defaults: get value of entry in defaults		*/
/*		 database				*/
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* SCCS information: %W%	%G% - NCSA */

/* #include "option.h" */

char           *
get_defaults (s)
	char           *s;
{
/* Implementation note(s):
	1. The default value will be "".
*/
	char           *value_s;

	value_s = defaults_get_string (s, "", 0);
	return ((*value_s == NULL) ? NULL : value_s);
}
/* EOF */
/* cat > src+obj/option/get_printer_field.c << "EOF" */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* get_printer_field: get the string up to the next	*/
/*		      | or : or \n or EOF		*/
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* SCCS information: %W%	%G% - NCSA */

/* #include "option.h" */

int
get_printer_field (fp, c, wkstr, maxlen) /* returns: either |, :, \n or EOF */
	FILE           *fp;
				/* input: file pointer of file to read */
	int             c;
				/* input: last character scanned so far */
	char           *wkstr;
				/* input: storage of size maxlen */
	int             maxlen;
				/* input: size of wkstr including \0. Must be at least 2 */
{
	int             n;

	n = 0;
	*wkstr++ = c;
	while ((c = getc (fp)) != EOF)
	{
		if (c != '|' && c != ':' && c != '\n')
		{
			if (n++ < maxlen - 1)
				*wkstr++ = c;
		}
		else
		{
			if (c == '\n' && *(wkstr - 1) == '\\')
				wkstr--;
			else
			{
				*wkstr = '\0';
				return (c);
			}
		}
	}
	*wkstr = '\0';
	return (EOF);
}
/* EOF */
/* cat > src+obj/option/getname_printer.c << "EOF" */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* getname_printer: get names from /etc/printcap and	*/
/*		    fill out menu print_menu		*/
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* SCCS information: %W%	%G% - NCSA */

/* #include "option.h" */

getname_printer (printer_menu)
	Menu            printer_menu;
				/* input: printer menu */
{
	FILE           *fp;
	int             found_lp;	/* lp string found - TRUE or FALSE */
	int             alias_number;	/* number of alias for a given printer */
	int             loop_printer_entry;	/* more printer aliases - TRUE or FALSE */
	char            wkstr[MAXNAMELEN], str[MAXNAMELEN];
	int             c;
	char           *dstr;

	char           *malloc ();

	if ((fp = fopen ("/etc/printcap", "r")) == NULL)
	{
		msg_write ("Error: Couldn't open /etc/printcap file to get printer names.");
		menu_set (printer_menu,
			  MENU_APPEND_ITEM,
			  menu_create_item (MENU_STRING, "Error: no names",
					    MENU_INACTIVE, TRUE,
					    0),
			  0);
		return (-1);
	}

		/* search /etc/printcap for entries and insert into menu */

	found_lp = FALSE;
	c = getc (fp);
	while (c != EOF)
	{
		*str = '\0';
		alias_number = 0;
		loop_printer_entry = TRUE;
		switch (c)
		{
			case ' ':
			case '\t':
			case '#':
				c = skip_to_newline (fp, c);
				loop_printer_entry = FALSE;
				break;
			case '\n':
				c = getc (fp);
				loop_printer_entry = FALSE;
				break;
			default:
				break;
		}
		while (loop_printer_entry)
		{
			c = get_printer_field (fp, c, wkstr, MAXNAMELEN);
			switch (c)
			{
				case '|':
				case ':':
					if (alias_number == 0)
					{
						strcpy (str, wkstr);
						if (!strcmp ("lp", wkstr))
							found_lp = TRUE;
						alias_number++;
					}
					else
					{
						if (!found_lp && !strcmp ("lp", wkstr))
						{
							found_lp = TRUE;
							(void) strcat (str, " (lp)");
						}
					}
					switch (c)
					{
						case '|':
							c = getc (fp);
							break;
						case ':':
							dstr = (char *) malloc (strlen (str) + 1);
							strcpy (dstr, str);
							menu_set (printer_menu,
								  MENU_APPEND_ITEM,
								  menu_create_item (MENU_STRING, dstr,
										    0),
								  0);

							c = skip_to_newline (fp, c);
							loop_printer_entry = FALSE;
							break;
					}
					break;
				case '\n':
					c = getc (fp);
					loop_printer_entry = FALSE;
					break;
				case EOF:
					loop_printer_entry = FALSE;
					break;
			}
		}
	}
	return (0);
}
/* EOF */
/* cat > src+obj/option/opt_handler.c << "EOF" */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* opt_handler: option handler				*/
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* SCCS information: %W%	%G% - NCSA */

/* #include "option.h" */

opt_handler (item, event)
	Panel_item      item;
	Event          *event;
{
	if (display_panel_menu (item, event, menu_panel, option_menu))
		set_defaults (option_menu, menu_get (option_menu, MENU_NTH_ITEM, 1));
}
/* EOF */
/* cat > src+obj/option/option_mark_menu.c << "EOF" */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* option_mark_menu: menu generate proc to set 		*/
/*		     reversed image and dark background */
/*		     strings in option menu.		*/
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* SCCS information: %W%	%G% - NCSA */

/* #include "option.h" */

Menu 
option_mark_menu (m, operation)
	Menu            m;
	Menu_generate   operation;
{
	int             which_button, i;
	static char     rev_image_on[] = "Set reversed image ON?";
	static char rev_image_off[] = "Set reversed image OFF?";
	static char dark_bg_on[] = "Set dark background ON?";
	static char     dark_bg_off[] = "Set dark background OFF?";

	switch (operation)
	{
		case MENU_DISPLAY:
			menu_set ((Menu_item) menu_get (m, MENU_NTH_ITEM, 3, 0), MENU_STRING, (rev_image) ? rev_image_off : rev_image_on, 0);
			menu_set ((Menu_item) menu_get (m, MENU_NTH_ITEM, 4, 0), MENU_STRING, (dark_bg) ? dark_bg_off : dark_bg_on, 0);
			break;

		case MENU_DISPLAY_DONE:

			break;

		case MENU_NOTIFY:

			break;

		case MENU_NOTIFY_DONE:

			break;
	}
		/* The current or newly-created menu is returned */
	return m;
}
/* EOF */
/* cat > src+obj/option/printer_proc.c << "EOF" */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* printer_proc: menu notify proc for printer menu	*/
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* SCCS information: %W%	%G% - NCSA */

/* #include "option.h" */

caddr_t 
printer_proc (m, mi)
	Menu            m;
	Menu_item       mi;
{
	char           *mstr;
	int             len;

	mstr = first_word ((char *) menu_get (mi, MENU_STRING), &len);
	strncpy (wkstr, mstr, len);
	*(wkstr + len) = '\0';

	panel_set_value (text_item, wkstr);
}
/* EOF */
/* cat > src+obj/option/put_defaults.c << "EOF" */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* put_defaults: save Imagetool defaults in		*/
/*		 $HOME/.defaults, the private user	*/
/*		 defaults database.			*/
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* SCCS information: %W%	%G% - NCSA */

/* #include "option.h" */

int 
put_defaults (dir, pal, help)
	char           *dir;
				/* input: default image directory pathname */
	char           *pal;
				/* input: default palette pathname */
	char           *help;
				/* input: help directory */
{
	int             status;

	defaults_set_string (DEFAULT_IMAGE_DIR, dir, NULL);
	defaults_set_string (DEFAULT_PALETTE_FILE, pal, NULL);
	defaults_set_string (DEFAULT_HELP_DIR, help, NULL);

	defaults_write_changed (NULL, NULL);
	return;
}
/* EOF */
/* cat > src+obj/option/set_darkbg.c << "EOF" */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* set_darkbg: (static) set dark background		*/
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* SCCS information: %W%	%G% - NCSA */

/* #include "option.h" */

static void
set_darkbg ()
{
	int             answer;

	if (dark_bg)
	{
		dark_bg = 0;
		msg_write ("Note: Dark background now OFF.");
	}
	else
	{
		dark_bg = 1;
		msg_write ("Note: Dark background now ON.");
	}

	init_cmsname ();
	reset_pal (REGULAR);

	return;
}
/* EOF */
/* cat > src+obj/option/set_defaults.c << "EOF" */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* set_defaults: set defaults				*/
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* SCCS information: %W%	%G% - NCSA */

/* #include "option.h" */

set_defaults ()
{
	panel_set_value (image_item, default_cdir);
	panel_set_value (pal_item, default_pal.fn);
	panel_set_value (help_item, help_dir);

	window_set (def_box, WIN_SHOW, TRUE, 0);
}
/* EOF */
/* cat > src+obj/option/set_printer.c << "EOF" */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* set_printer: set printer 				*/
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* SCCS information: %W%	%G% - NCSA */

/* #include "option.h" */

set_printer (m, mi)
	Menu            m;
	Menu_item       mi;
{
/* Implementation note(s):
	1. printer is initialized in function init_vars.
*/
	char            str[MAXNAMELEN];
	int             answer;

	sprintf (str, "%s", printer);
	while ((answer = mydialog ("Printer name:", NULL, str, 0, 64, 64, printer_menu)))
	{
		if (strip_wspace (str) > 0)
		{
			if (word_count (str) != 1)	/* must be one word */
				msg_write ("Error: Printer name must be one word. Please retype or cancel.");
			else
			{
				strcpy (printer, str);
				break;
			}
		}
		else
			msg_write ("Error: No printer name. Please type one in or cancel.");
	}
}
/* EOF */
/* cat > src+obj/option/set_reversed.c << "EOF" */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* set_reversed: (static) set reserve image		*/
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* SCCS information: %W%	%G% - NCSA */

/* #include "option.h" */

static void
set_reversed ()
{
	if (rev_image)
	{
		rev_image = 0;
		msg_write ("Note: Reverse image now OFF.");
	}
	else
	{
		rev_image = 1;
		msg_write ("Note: Reverse image now ON.");
	}
	return;
}
/* EOF */
/* cat > src+obj/option/skip_to_newline.c << "EOF" */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* skip_to_newline: skip all characters on fp until	*/
/*		    newline not preceeded by \		*/
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* SCCS information: %W%	%G% - NCSA */

/* #include "option.h" */

int
skip_to_newline (fp, c)	/* returns: next character or EOF after newline */
	FILE           *fp;
				/* input: file pointer of file to read */
	int             c;
				/* input: last character scanned */
{
	int             c0, c1;

	c0 = c;
	c1 = getc (fp);
	while (c1 != EOF)
		if (c1 == '\n' && c0 != '\\')
			return (getc (fp));
		else
		{
			c0 = c1;
			c1 = getc (fp);
		}
	return (EOF);
}
/* EOF */
/* cat > src+obj/option/update_default_help.c << "EOF" */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* update_default_help: updates the defaults panel 	*/
/*			text help_item with directory	*/
/*		        from pathname frame		*/
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* SCCS information: %W%	%G% - NCSA */

/* #include "option.h" */

int
update_default_help (dir, file)
	char           *dir;
	char           *file;
{
	panel_set_value (help_item, dir);
}
/* EOF */
/* cat > src+obj/option/update_default_image.c << "EOF" */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* update_default_image: updates the defaults panel 	*/
/*			 text image_item with directory	*/
/*		         from pathname frame		*/
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* SCCS information: %W%	%G% - NCSA */

/* #include "option.h" */

int
update_default_image (dir, file)
	char           *dir;
	char           *file;
{
	panel_set_value (image_item, dir);
}
/* EOF */
/* cat > src+obj/option/update_default_pal.c << "EOF" */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* update_default_pal: updates the defaults panel 	*/
/*		       text pal_item with filename	*/
/*		       from pathname frame		*/
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* SCCS information: %W%	%G% - NCSA */

/* #include "option.h" */

int
update_default_pal (dir, file)
	char           *dir;
	char           *file;
{
	sprintf (wkstr, "%s/%s", dir, file);
	panel_set_value (pal_item, wkstr);
}
/* EOF */
